/*

  JFwadmin v 0.71

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

package fwadmin;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;

import fwadmin.*; 

public class Fwadmin extends JFrame implements ActionListener
{
  JMenuBar m_fwadminJMenuBar = new JMenuBar();
  JTabbedPane m_fwadminJTabbedPane = new JTabbedPane();
  protected static Vector updateWindowVector = new Vector();
  private static Fwadmin m_instance;


  private AddInputServiceDialog m_AddInputServiceDialog = null;
  private AddOutputServiceDialog m_AddOutputServiceDialog = null;
  private AddForwardServiceDialog m_AddForwardServiceDialog = null;
  private AddAntiSpoofingServiceDialog m_AddAntiSpoofingServiceDialog = null;
  private AddLogDeniedPacketsServiceDialog m_AddLogDeniedPacketsServiceDialog = null;

  private JLabel statusJLabel = null;
  private JPanel statusJPanel = null;

  JMenuItem refreshDataMenuItem;
  JMenuItem applyChangesMenuItem;
  JMenuItem saveFirewallMenuItem;
  JMenuItem restoreFirewallMenuItem;
  JMenuItem saveBootScriptMenuItem;
  JMenuItem exitMenuItem;
  JMenuItem newInputServiceMenuItem;
  JMenuItem newOutputServiceMenuItem;
  JMenuItem newForwardServiceMenuItem;
  JMenuItem newAntiSpooffingServiceMenuItem;
  JMenuItem newLogTheRestServiceMenuItem;

  public static Fwadmin getInstance()
  {
    if (m_instance == null) m_instance = new Fwadmin();
    return m_instance; 
  }

private Fwadmin()
{
	super(getNameAndVersion());

	this.setSize(800, 400);
	this.getContentPane().setLayout(new BorderLayout());

  JMenu m_fileJMenu = new JMenu();
  JMenu m_ruleJMenu = new JMenu();
  m_fileJMenu.setText("File");
  m_ruleJMenu.setText("Services");

  refreshDataMenuItem = new JMenuItem();
  refreshDataMenuItem.setText("Refresh data from system");
  refreshDataMenuItem.addActionListener(this);
  applyChangesMenuItem = new JMenuItem();
  applyChangesMenuItem.setText("Apply changes");
  applyChangesMenuItem.addActionListener(this);
  saveFirewallMenuItem = new JMenuItem();
  saveFirewallMenuItem.setText("Save firewall");
  saveFirewallMenuItem.addActionListener(this);
  restoreFirewallMenuItem = new JMenuItem();
  restoreFirewallMenuItem.setText("Restore firewall");
  restoreFirewallMenuItem.addActionListener(this);
  saveBootScriptMenuItem = new JMenuItem();
  saveBootScriptMenuItem.setText("Save boot script");
  saveBootScriptMenuItem.addActionListener(this);
  exitMenuItem = new JMenuItem();
  exitMenuItem.setText("Exit");
  exitMenuItem.addActionListener(this);

  newInputServiceMenuItem = new JMenuItem();
  newInputServiceMenuItem.setText("New input service");
  newInputServiceMenuItem.addActionListener(this);
  newOutputServiceMenuItem = new JMenuItem();
  newOutputServiceMenuItem.setText("New output service");
  newOutputServiceMenuItem.addActionListener(this);
  newForwardServiceMenuItem = new JMenuItem();
  newForwardServiceMenuItem.setText("New forward service");
  newForwardServiceMenuItem.addActionListener(this);
  newAntiSpooffingServiceMenuItem = new JMenuItem();
  newAntiSpooffingServiceMenuItem.setText("New Anti spooffing service");
  newAntiSpooffingServiceMenuItem.addActionListener(this);
  newLogTheRestServiceMenuItem = new JMenuItem();
  newLogTheRestServiceMenuItem.setText("New Log denied packets service");
  newLogTheRestServiceMenuItem.addActionListener(this);

  m_fileJMenu.add(refreshDataMenuItem);
  m_fileJMenu.add(applyChangesMenuItem);
  m_fileJMenu.addSeparator();
  m_fileJMenu.add(saveFirewallMenuItem);
  m_fileJMenu.add(restoreFirewallMenuItem);
  m_fileJMenu.addSeparator();
  m_fileJMenu.add(saveBootScriptMenuItem);
  m_fileJMenu.addSeparator();
  m_fileJMenu.add(exitMenuItem);

  m_ruleJMenu.add(newInputServiceMenuItem);
  m_ruleJMenu.add(newOutputServiceMenuItem);
  m_ruleJMenu.add(newForwardServiceMenuItem);
  m_ruleJMenu.addSeparator();
  m_ruleJMenu.add(newAntiSpooffingServiceMenuItem);
  m_ruleJMenu.add(newLogTheRestServiceMenuItem);

  m_fwadminJMenuBar.add(m_fileJMenu);
  DefaultPolicy.getInstance().addPoliciesMenu(m_fwadminJMenuBar);
  m_fwadminJMenuBar.add(m_ruleJMenu);
  getContentPane().add(m_fwadminJTabbedPane,BorderLayout.CENTER);
  JPanel topJPanel = new JPanel();
  topJPanel.setLayout(new GridLayout(1, 2));
  topJPanel.add(m_fwadminJMenuBar);
  statusJPanel = new JPanel();
  statusJPanel.setBorder(BorderFactory.createLineBorder(Color.black, 1));
  statusJPanel.setLayout(new FlowLayout());
  statusJLabel = new JLabel();
  statusJPanel.add(statusJLabel);
  topJPanel.add(statusJPanel);
  getContentPane().add(topJPanel, BorderLayout.NORTH);

	addWindowListener(new WindowAdapter()
  {
    public void windowClosing(WindowEvent e)
    {
      if (changesAreNotApplied())
      {
        int res = JOptionPane.showConfirmDialog(Fwadmin.getInstance(), "Unapplied rules will be lost (you have some). Do you want to apply rules before exit ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
        if (res == JOptionPane.YES_OPTION)
        {
          try
          {
            Linux22.applyRules();
          }
          catch(Exception e2)
          {
            JOptionPane.showMessageDialog(Fwadmin.getInstance(), "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
          }
          makeChangesApplied();
        }
      }
      dispose();
      System.exit(0);
    }
  }
  );
}
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() instanceof JMenuItem)
    {
      if(e.getSource().equals(refreshDataMenuItem))
      {
        if (changesAreNotApplied())
        {
          int res = JOptionPane.showConfirmDialog(this, "Unapplied rules will be lost (you have some). Do you want to continue ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
          if (res == JOptionPane.NO_OPTION) return;
        }
        refreshDataFromSystem();
      }
      if(e.getSource().equals(applyChangesMenuItem))
      {
        try
        {
          Linux22.applyRules();
        }
        catch(Exception e3)
        {
          JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
        }
        makeChangesApplied();
        // This question is commented out, cause i always say yes...
        //int res = JOptionPane.showConfirmDialog(this, "Do you want to refresh data from system now ?", "Question - hint : say yes :)", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        //if (res == JOptionPane.NO_OPTION) return;
        refreshDataFromSystem();
      }
      if(e.getSource().equals(saveFirewallMenuItem))
      {
        if (changesAreNotApplied())
        {
          int res = JOptionPane.showConfirmDialog(this, "Unapplied rules will not be saved (you have some). Do you want to continue ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
          if (res == JOptionPane.NO_OPTION) return;
        }
		    JFileChooser chooser = new JFileChooser();
		    int retval = chooser.showOpenDialog(this);
		    if(retval == 0)
        {
			    File theFile = chooser.getSelectedFile();
			    if(theFile != null)
          {
            saveFirewall(chooser);
          }
        }
        return;
      }
      else
      if(e.getSource().equals(restoreFirewallMenuItem))
      {
        if (changesAreNotApplied())
        {
          int res = JOptionPane.showConfirmDialog(this, "Unapplied rules will be lost (you have some). Do you really want to continue ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
          if (res == JOptionPane.NO_OPTION) return;
        }
		    JFileChooser chooser = new JFileChooser();
		    int retval = chooser.showOpenDialog(this);
		    if(retval == 0)
        {
			    File theFile = chooser.getSelectedFile();
			    if(theFile != null)
          {
            restoreFirewall(chooser);
          }
        }
        int res = JOptionPane.showConfirmDialog(this, "Do you want to refresh data from system now ?", "Question - hint : say yes :)", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (res == JOptionPane.NO_OPTION) return;
        refreshDataFromSystem();
        return;
      }
      else
      if(e.getSource().equals(saveBootScriptMenuItem))
      {
        if (changesAreNotApplied())
        {
          int res = JOptionPane.showConfirmDialog(this, "Unapplied rules will be written to boot file. Do you want to continue ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
          if (res == JOptionPane.NO_OPTION) return;
        }
		    JFileChooser chooser = new JFileChooser();
		    int retval = chooser.showOpenDialog(this);
		    if(retval == 0)
        {
			    File theFile = chooser.getSelectedFile();
			    if(theFile != null)
          {
            try
            {
              PrintWriter pw = new PrintWriter(new FileWriter(chooser.getSelectedFile().getAbsolutePath()));
              Linux22.saveBootScript(pw);
            }
            catch(Exception e2)
            {
              JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
            }
          }
        }
        return;
      }
      else
      if(e.getSource().equals(exitMenuItem))
      {
        if (changesAreNotApplied())
        {
          int res = JOptionPane.showConfirmDialog(this, "Unapplied rules will be lost (you have some). Do you really want to exit ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
          if (res == JOptionPane.NO_OPTION) return;
        }
        System.exit(0);
      }
      else
      if(e.getSource().equals(newInputServiceMenuItem))
      {
        if (m_AddInputServiceDialog == null) m_AddInputServiceDialog = new AddInputServiceDialog(this, "Add input service", true);
        m_AddInputServiceDialog.resetOK();
        m_AddInputServiceDialog.setVisible(true);
        if (m_AddInputServiceDialog.getOK() == true)
        {
          refreshPanels();
        }
      }
      else
      if(e.getSource().equals(newOutputServiceMenuItem))
      {
        if (m_AddOutputServiceDialog == null) m_AddOutputServiceDialog = new AddOutputServiceDialog(this, "Add output service", true);
        m_AddOutputServiceDialog.resetOK();
        m_AddOutputServiceDialog.setVisible(true);
        if (m_AddOutputServiceDialog.getOK() == true)
        {
          refreshPanels();
        }
      }
      else
      if(e.getSource().equals(newForwardServiceMenuItem))
      {
        if (m_AddForwardServiceDialog == null) m_AddForwardServiceDialog = new AddForwardServiceDialog(this, "Add forward service", true);
        m_AddForwardServiceDialog.resetOK();
        m_AddForwardServiceDialog.setVisible(true);
        if (m_AddForwardServiceDialog.getOK() == true)
        {
          refreshPanels();
        }
      }
      else
      if(e.getSource().equals(newAntiSpooffingServiceMenuItem))
      {
        if (m_AddAntiSpoofingServiceDialog == null) m_AddAntiSpoofingServiceDialog = new AddAntiSpoofingServiceDialog(this, "Add anti spoofing service", true);
        m_AddAntiSpoofingServiceDialog.resetOK();
        m_AddAntiSpoofingServiceDialog.setVisible(true);
        if (m_AddAntiSpoofingServiceDialog.getOK() == true)
        {
          refreshPanels();
        }
      }
      else
      if(e.getSource().equals(newLogTheRestServiceMenuItem))
      {
        if (m_AddLogDeniedPacketsServiceDialog == null) m_AddLogDeniedPacketsServiceDialog = new AddLogDeniedPacketsServiceDialog(this, "Add log of denied packets service", true);
        m_AddLogDeniedPacketsServiceDialog.resetOK();
        m_AddLogDeniedPacketsServiceDialog.setVisible(true);
        if (m_AddLogDeniedPacketsServiceDialog.getOK() == true)
        {
          refreshPanels();
        }
      }

    }
	}

public void saveFirewall(JFileChooser chooser)
{
  try
  {
    PrintWriter pw = new PrintWriter(new FileWriter(chooser.getSelectedFile().getAbsolutePath()));
    Process p = Runtime.getRuntime().exec(new String[] {"/sbin/ipchains-save"});
    BufferedReader bf = new BufferedReader(new InputStreamReader(p.getInputStream()));
    while(true)
    {
      String line = bf.readLine();
      if(line == null) break;
      pw.println(line);
    }
    p.waitFor();
    int res = p.exitValue();
    if (res != 0) JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
    pw.flush();
    pw.close();
  }
  catch(Exception error)
  {
    JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
  }
}
public void restoreFirewall(JFileChooser chooser)
{
  try
  {
    // Flush input rules
    Process p = Runtime.getRuntime().exec(new String[] {"/sbin/ipchains", "-F", "input"});
    p.waitFor();
    int res = p.exitValue();
    if (res != 0) throw new Exception("There was an error.");
    // Flush output rules
    p = Runtime.getRuntime().exec(new String[] {"/sbin/ipchains", "-F", "output"});
    p.waitFor();
    res = p.exitValue();
    if (res != 0) throw new Exception("There was an error.");
    // Flush output rules
    p = Runtime.getRuntime().exec(new String[] {"/sbin/ipchains", "-F", "forward"});
    p.waitFor();
    res = p.exitValue();
    if (res != 0) throw new Exception("There was an error.");

    BufferedReader br = new BufferedReader(new FileReader(chooser.getSelectedFile().getAbsolutePath()));
    p = Runtime.getRuntime().exec(new String[] {"/sbin/ipchains-restore"});
    PrintWriter pw = new PrintWriter(new OutputStreamWriter(p.getOutputStream()));
    while(true)
    {
      String line = br.readLine();
      if(line == null) break;
      pw.println(line);
    }
    pw.flush();
    pw.close();
    p.waitFor();
    res = p.exitValue();
    if (res != 0) JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
  }
  catch(Exception error)
  {
    JOptionPane.showMessageDialog(this, "There was an error", "Error", JOptionPane.ERROR_MESSAGE);
  }
}
public void refreshDataFromSystem()
{
  InputService.inputServicesVector.removeAllElements();
  OutputService.outputServicesVector.removeAllElements();
  InputRule.inputRulesVector.removeAllElements();
  OutputRule.outputRulesVector.removeAllElements();
  InputOutputRule.miscRulesVector.removeAllElements();
  ForwardRule.forwardRulesVector.removeAllElements();
  Linux22.readFirewallRules();
  Service.initServices();
  makeChangesApplied();
  refreshPanels();
}
public void statusMessage(Color c, String txt)
{
  statusJLabel.setForeground(c);
  statusJLabel.setText(txt);
  statusJPanel.repaint();
}
public boolean changesAreNotApplied()
{
  if (DefaultPolicy.defaultInputNotApplied) return true;
  if (DefaultPolicy.defaultOutputNotApplied) return true;
  if (DefaultPolicy.defaultForwardNotApplied) return true;

  if (InputRule.changesAreNotApplied()) return true;
  if (OutputRule.changesAreNotApplied()) return true;
  if (ForwardRule.changesAreNotApplied()) return true;
  if (InputOutputRule.changesAreNotApplied()) return true;

  return false;
}
public void makeChangesApplied()
{
  DefaultPolicy.defaultInputNotApplied = false;
  DefaultPolicy.defaultOutputNotApplied = false;
  DefaultPolicy.defaultForwardNotApplied = false;

  InputRule.makeChangesApplied();
  OutputRule.makeChangesApplied();
  ForwardRule.makeChangesApplied();
}

public void makePanels()
{
  InputServicesPanel isp = new InputServicesPanel();
  m_fwadminJTabbedPane.addTab("Input services",null, isp, "Input services view");
  updateWindowVector.addElement(isp);

  OutputServicesPanel osp = new OutputServicesPanel();
  m_fwadminJTabbedPane.addTab("Output services",null, osp, "Output services view");
  updateWindowVector.addElement(osp);

  ForwardServicesPanel fsp = new ForwardServicesPanel();
  m_fwadminJTabbedPane.addTab("Forward services",null, fsp, "Forward services view");
  updateWindowVector.addElement(fsp);

  MiscRulesPanel mrp = new MiscRulesPanel();
  m_fwadminJTabbedPane.addTab("Misc rules",null, mrp, "Bogus : you should not have misc rules");
  updateWindowVector.addElement(mrp);
}

public void refreshPanels()
{
  for (int i=0; i < updateWindowVector.size(); i++)
  {
    ((UpdateWindow)updateWindowVector.elementAt(i)).updateWindow();
  }
  if (changesAreNotApplied())
  {
    statusMessage(Color.red, "Changes you made are not applied");
  }
  else
  {
    statusMessage(Color.green, "Current configuration is displayed");
  }
}

public static String getNameAndVersion()
{
  return "JFwadmin 0.71";
}

public static void startFwadmin(String args[])
{
  try
  {
    UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
  }
  catch (Exception e)
  {
    System.out.println("Unsupported LookAndFeel : Motif");
  }

  Linux22.readNetConfig();
  Linux22.readFirewallRules();
  Service.initServices();
	Fwadmin.getInstance().setVisible(true);

  (new SystemDialog(Fwadmin.getInstance(), "IP configuration", true)).setVisible(true);

  Fwadmin.getInstance().makePanels();
  Fwadmin.getInstance().refreshPanels();
}
}
